<template>
  <v-app dark>
    <!-- theme setting -->
    <v-btn
      small
      fab
      dark
      fixed
      top="top"
      right="right"
      class="setting-fab"
      color="red"
      @click="openThemeSettings"
    >
      <v-icon>mdi-silverware-variant</v-icon>
    </v-btn>
    <!-- theme setting drawer -->
    <v-navigation-drawer
      v-model="rightDrawer"
      class="setting-drawer"
      temporary
      right
      hide-overlay
      fixed
    >
      <template v-if="showSetting">
        <theme-settings />
      </template>
    </v-navigation-drawer>

    <!-- nav drawer -->
    <v-navigation-drawer
      v-model="drawer"
      :mini-variant="miniVariant"
      mini-variant-width="64"
      :clipped="true"
      fixed
      app
    >
      <!-- menu -->
      <v-list>
        <v-list-item
          v-for="(item, i) in items"
          :key="i"
          :to="item.to"
          router
          exact
        >
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title v-text="item.title" />
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <template #append>
        <div class="lighten-3">
          <template v-if="miniVariant">
            <v-btn
              block
              width="64"
              height="48"
              icon
              tile
              class="mx-auto"
              @click="handleDrawerCollapse"
            >
              <v-icon>mdi-arrow-collapse-right</v-icon>
            </v-btn>
          </template>
          <template v-else>
            <v-btn
              right
              block
              height="48"
              icon
              tile
              @click="handleDrawerCollapse"
            >
              <v-icon>mdi-arrow-collapse-left</v-icon>
            </v-btn>
          </template>
        </div>
      </template>
    </v-navigation-drawer>

    <!-- app-bar -->
    <v-app-bar
      :clipped-left="clipped"
      fixed
      app
      color="primary"
      dark
      flat
      dense
    >
      <v-btn text class="pl-2">
        <img :src="computeLogo()" height="24" alt="Finch" />
        <span class="hidden-sm-and-down left-header-title">Finch</span>
      </v-btn>

     <v-btn text @click.stop="drawer = !drawer" >
        <v-icon>mdi-menu</v-icon>
      </v-btn>

      <v-spacer />

      <!-- fullscreen -->
      <v-btn text @click="handleFullscreen()">
        <v-icon>mdi-fullscreen</v-icon>
      </v-btn>
    </v-app-bar>
    <v-main>
      <v-container>
        <page-header :title="this.$route.name" />
        <v-divider />
        <br />

        <Nuxt />
      </v-container>
      <!-- <page-footer /> -->
    </v-main>
  </v-app>
</template>

<script>
import ThemeSettings from "@/components/ThemeSettings";
import PageHeader from "@/components/PageHeader";
import Util from "@/util";

export default {
  components: {
    ThemeSettings,
    PageHeader
  },
  data() {
    return {
      miniVariant: true,
      rightDrawer: false,
      showSetting: true,
      clipped: true,
      drawer: true,
      items: [
        {
          icon: "mdi-android",
          title: "Select Target",
          to: "/select_target"
        },
        {
          icon: "mdi-magnify",
          title: "Dynamic Analysis",
          to: "/dynamic_analysis"
        }
      ],
      title: ""
    };
  },
  mounted() {
    if (typeof window !== undefined && window._VMA === undefined) {
      window._VMA = this;
    }
  },
  methods: {
    openThemeSettings() {
      this.$vuetify.goTo(0);
      this.showSetting = true;
      this.rightDrawer = !this.rightDrawer;
    },
    openOnlineUser() {
      this.$vuetify.goTo(0);
      this.showSetting = false;
      this.rightDrawer = !this.rightDrawer;
    },
    computeLogo() {
      return "/bird1.png";
    },
    handleDrawerCollapse() {
      this.miniVariant = !this.miniVariant;
    },
    handleFullscreen() {
      console.log("clicked");
      console.log(Util);
      Util.toggleFullscreen();
    },
    handleGoBack() {
      this.$router.go(-1);
    },
    goHome() {
      this.$router.push("/");
    }
  }
};
</script>

<style lang="sass" scoped>
.left-header-title
  margin-left: 0.5em
  font-size: 1.2rem
  font-weight: 400

.setting-fab
  top: 50% !important
  right: 0
  border-radius: 0
</style>
